#include "JZEvent.h"

ClassImp (JZEventHeader)
ClassImp (JZHlep)
ClassImp (JZElectron)
ClassImp (JZMuon)
ClassImp (JZJet)
ClassImp (JZIsoTrack)
ClassImp (JZMissingEt)
ClassImp (JZEvent)

JZEvent::JZEvent()
{
    fNHlep = 0;
    fNEle = 0;
    fNMu = 0;
    fNJet = 0;
    fNIsoTrk = 0;
    fHleps     = new TClonesArray("JZHlep",10);
    fElectrons = new TClonesArray("JZElectron",50);
    fMuons     = new TClonesArray("JZMuon",50);
    fJets      = new TClonesArray("JZJet",100);
    fIsoTracks = new TClonesArray("JZIsoTrack",50);
}

JZEvent::~JZEvent()
{
    Clear();

    delete fHleps;      fHleps=0;
    delete fElectrons;  fElectrons=0;
    delete fMuons;      fMuons=0;
    delete fJets;       fJets=0;
    delete fIsoTracks;  fIsoTracks=0;
}

JZEventHeader::JZEventHeader()
{
    fRunNum = 0;
    fEvtNum = 0;
    fNvtx = 0;
    fVx = -999.;
    fVy = -999.;
    fVz = -999.;
    fSumEt = 0.;
    fCosmic = 0;
}

//void JZEventHeader::Clear(Option_t *option)
//{
//    fRunNum = 0;
//    fEvtNum = 0;
//    fNvtx = 0;
//    fVx = -999.;
//    fVy = -999.;
//    fVz = -999.;
//    fSumEt = 0.;
//    fCosmic = 0;
//}

void JZEventHeader::Print(Option_t *option) const
{
    cout << "Runnum=" << fRunNum << " Evtnum=" << fEvtNum << " Nvtx=" << fNvtx << " Vtx=(" << fVx << "," << fVy << "," << fVz << ") SumEt=" << fSumEt << " Cosmic=" << fCosmic << " TrigBit=" << hex << fTrigBit << dec << endl ;
}


JZHlep *JZEvent::AddHlep()
{
    TClonesArray &hleps = *fHleps;
    JZHlep *hlep = new(hleps[fNHlep++]) JZHlep();
    return hlep;
}

void JZHlep::Print(Option_t *option) const
{
    if ( strcmp(option,"") == 0 )
        printf("%6d%9.2f%9.2f%9.2f%10d%9.2f%9.2f%9.2f\n",fID,fPt,fEta,fPhi,fpID,fpPt,fpEta,fpPhi);
}

JZElectron *JZEvent::AddElectron()
{
    TClonesArray &eles = *fElectrons;
    JZElectron *ele = new(eles[fNEle++]) JZElectron();
    return ele;
}

void JZElectron::Print(Option_t *option) const
{
    if ( strcmp(option,"") == 0 )
        printf("%5d%8.2f%8.3f%8.3f%8.4f%7.3f%7.3f%7.3f%7.3f%8.3f%4d%3d%7.3f%6d%6d%8.2f%8.2f%8.3f%8.2f%3d%3d%3d%3d\n",fCharge,fEt,fEta,fPhi,fHadEm,fEoP,fLshr,fDx,fDz,fChi2Strip,fFidEle,fTrig,fIsofrac,fTrkNum,fnCOTHits,fTrkPt,fTrkZ0,fTrkD0,fCOTChi2,fnCOTSegAx5,fnCOTSegSt5,fnCOTSegAx7,fnCOTSegSt7);
}

JZMuon *JZEvent::AddMuon()
{
    TClonesArray &mus = *fMuons;
    JZMuon *mu = new(mus[fNMu++]) JZMuon();
    return mu;
}

void JZMuon::Print(Option_t *option) const
{
    if ( strcmp(option,"") == 0 ) {
        if ( fType==1 )
            printf("CMU - %5d%8.2f%8.2f%8.2f%7.2f%7.2f%7.2f%7.2f%7.2f%4d%6d%6d%8.2f%8.2f%8.3f%8.2f%3d%3d%3d%3d\n",fCharge,fPt,fEta,fPhi,fEmEn,fHadEn,fChi2Match,fDx,fIsofrac,fTrig,fTrkNum,fnCOTHits,fTrkPt,fTrkZ0,fTrkD0,fCOTChi2,fnCOTSegAx5,fnCOTSegSt5,fnCOTSegAx7,fnCOTSegSt7);
        else if ( fType==2 )
            printf("CMP - %5d%8.2f%8.2f%8.2f%7.2f%7.2f%7.2f%7.2f%7.2f%4d%6d%6d%8.2f%8.2f%8.3f%8.2f%3d%3d%3d%3d\n",fCharge,fPt,fEta,fPhi,fEmEn,fHadEn,fChi2Match,fDx,fIsofrac,fTrig,fTrkNum,fnCOTHits,fTrkPt,fTrkZ0,fTrkD0,fCOTChi2,fnCOTSegAx5,fnCOTSegSt5,fnCOTSegAx7,fnCOTSegSt7);
        else if ( fType==3 )
            printf("CMUP -%5d%8.2f%8.2f%8.2f%7.2f%7.2f%7.2f%7.2f%7.2f%4d%6d%6d%8.2f%8.2f%8.3f%8.2f%3d%3d%3d%3d\n",fCharge,fPt,fEta,fPhi,fEmEn,fHadEn,fChi2Match,fDx,fIsofrac,fTrig,fTrkNum,fnCOTHits,fTrkPt,fTrkZ0,fTrkD0,fCOTChi2,fnCOTSegAx5,fnCOTSegSt5,fnCOTSegAx7,fnCOTSegSt7);
        else if ( fType==4 )
            printf("CMX - %5d%8.2f%8.2f%8.2f%7.2f%7.2f%7.2f%7.2f%7.2f%4d%6d%6d%8.2f%8.2f%8.3f%8.2f%3d%3d%3d%3d\n",fCharge,fPt,fEta,fPhi,fEmEn,fHadEn,fChi2Match,fDx,fIsofrac,fTrig,fTrkNum,fnCOTHits,fTrkPt,fTrkZ0,fTrkD0,fCOTChi2,fnCOTSegAx5,fnCOTSegSt5,fnCOTSegAx7,fnCOTSegSt7);
    }
}

JZJet *JZEvent::AddJet()
{
    TClonesArray &jets = *fJets;
    JZJet *jet = new(jets[fNJet++]) JZJet();
    return jet;
}

void JZJet::Print(Option_t *option) const
{
    if ( strcmp(option,"") == 0 )
        printf("%4d%8.2f%8.2f%8.2f%8.2f%8.2f%8.3f%8.3f%8.3f%8.3f%8.3f\n",fTrig,fEt,fEta,fPhi,fEmf,fPt,fJEScale3,fJEScale4,fJEScale5,fJEScale6,fJEScale7);
}

JZIsoTrack *JZEvent::AddIsoTrack()
{
    TClonesArray &isotrks = *fIsoTracks;
    JZIsoTrack *isotrk = new(isotrks[fNIsoTrk++]) JZIsoTrack();
    return isotrk;
}

void JZIsoTrack::Print(Option_t *option) const
{
    if ( strcmp(option,"") == 0 )
        printf("%6d%6d%8.2f%8.2f%8.2f%8.2f%8.2f%8.2f%8.2f%8.2f%3d%3d%3d%3d\n",fTrkNum,fnCOTHits,fTrkPt,fTrkEta,fTrkPhi,fTrkZ0,fCOTChi2,fSumP,fSumPt,fIso4,fnCOTSegAx5,fnCOTSegSt5,fnCOTSegAx7,fnCOTSegSt7);
}

//void JZMissingEt::Clear(Option_t *option)
//{
//    fMet=0.;
//    fPhi=0.;
//    fMetHepg=0.;
//    fPhiHepg=0.;
//}

void JZMissingEt::Print(Option_t *option) const
{
    printf("Met=%9.2f MetPhi=%9.2f; MetHepg=%9.2f MetHepgPhi=%9.2f\n",fMet,fPhi,fMetHepg,fPhiHepg);
}

void JZEvent::Clear(Option_t *option)
{
    fNHlep = 0;
    fNEle = 0;
    fNMu = 0;
    fNJet = 0;
    fNIsoTrk = 0;
    fEvtHdr.Clear();
    fMet.Clear();
    fHleps->Clear("C");
    fElectrons->Clear("C");
    fMuons->Clear("C");
    fJets->Clear("C");
    fIsoTracks->Clear("C");
// The following alternatives also work.
//    fHleps->Delete();
//    fElectrons->Delete();
//    fMuons->Delete();
//    fJets->Delete();
//    fIsoTracks->Delete();
}

void JZEvent::PrintEvent(int i) const
{
    if ( i==0 ) {
        cout << endl << " ----------------- Event Information ------------------" << endl;
        fEvtHdr.Print();

        cout << endl << " ------------------ Met Information -------------------" << endl;
        fMet.Print();

        cout << endl << " ------------------ HEPG Information ------------------" << endl;
        cout << "   Number of HEPG leptons in this event = " << fNHlep << endl;
        for ( int j=0; j<fNHlep; j++ ) {
            JZHlep *lep = Hlep(j);
            cout << "Hepg Lep: " << j << "   "; lep->Print();
        }
        cout << endl << " ---------------- Electron Information ----------------" << endl;
        cout << "   Number of ELECTRONS in this event = " << fNEle << endl;
        for ( int j=0; j<fNEle; j++ ) {
            JZElectron *ele = Ele(j);
            cout << "Electron: " << j << "   "; ele->Print();
        }
        cout << endl << " ------------------ Muon Information ------------------" << endl;
        cout << "   Number of MUONS in this event = " << fNMu << endl;
        for ( int j=0; j<fNMu; j++ ) {
            JZMuon *mu = Mu(j);
            cout << "Muon:     " << j << "   "; mu->Print();
        }
        cout << endl << " ------------------- Jet Information ------------------" << endl;
        cout << "   Number of JETS in this event = " << fNJet << endl;
        for ( int j=0; j<fNJet; j++ ) {
            JZJet *jet = Jt(j);
            cout << "Jet:      " << j << "   "; jet->Print();
        }
        cout << endl << " ---------------- IsoTrack Information ----------------" << endl;
        cout << "   Number of ISOTRACKS in this event = " << fNIsoTrk << endl;
        for ( int j=0; j<fNIsoTrk; j++ ) {
            JZIsoTrack *isotrk = IsoTrk(j);
            cout << "IsoTrack: " << j << "   "; isotrk->Print();
        }
    }
    else if ( i==1 ) {
        cout << endl << " ----------------- Event Information ------------------" << endl;
        fEvtHdr.Print();
    }
    else if ( i==2 ) {
        cout << endl << " ------------------ Met Information -------------------" << endl;
        fMet.Print();
    }
    else if ( i==3 ) {
        cout << endl << " ------------------ HEPG Information ------------------" << endl;
        cout << "   Number of HEPG leptons in this event = " << fNHlep << endl;
        for ( int j=0; j<fNHlep; j++ ) {
            JZHlep *lep = Hlep(j);
            cout << "Hepg Lep: " << j << "   "; lep->Print();
        }
    }
    else if ( i==4 ) {
        cout << endl << " ---------------- Electron Information ----------------" << endl;
        cout << "   Number of ELECTRONS in this event = " << fNEle << endl;
        for ( int j=0; j<fNEle; j++ ) {
            JZElectron *ele = Ele(j);
            cout << "Electron: " << j << "   "; ele->Print();
        }
    }
    else if ( i==5 ) {
        cout << endl << " ------------------ Muon Information ------------------" << endl;
        cout << "   Number of MUONS in this event = " << fNMu << endl;
        for ( int j=0; j<fNMu; j++ ) {
            JZMuon *mu = Mu(j);
            cout << "Muon:     " << j << "   "; mu->Print();
        }
    }
    else if ( i==6 ) {
        cout << endl << " ------------------- Jet Information ------------------" << endl;
        cout << "   Number of JETS in this event = " << fNJet << endl;
        for ( int j=0; j<fNJet; j++ ) {
            JZJet *jet = Jt(j);
            cout << "Jet:      " << j << "   "; jet->Print();
        }
        if ( fNJet==0 ) cout << "There is no JET in this event." << endl;
    }
    else if ( i==7 ) {
        cout << endl << " ---------------- IsoTrack Information ----------------" << endl;
        cout << "   Number of ISOTRACKS in this event = " << fNIsoTrk << endl;
        for ( int j=0; j<fNIsoTrk; j++ ) {
            JZIsoTrack *isotrk = IsoTrk(j);
            cout << "IsoTrack: " << j << "   "; isotrk->Print();
        }
    }
}
