#ifndef Lepton_h
#define Lepton_h
#include "TRefArray.h"
#include "TRef.h"
#include <math.h>

class Lepton{
  public:
    Lepton();
    ~Lepton();

    float px()      { return _px; }
    float py()      { return _py; }
    float pz()      { return _pz; }
    float pt()      { return _pt; }
    float en()      { return _en; }
    float et()      { return _et; }
    float eta()     { return _eta; }
    float phi()     { return _phi; }
    float z0()      { return _z0; }
    int  id()       { return _id; }
    unsigned qual()  { return _qual; }
    unsigned qual2() { return _qual2; }
    unsigned qual3() { return _qual3; }
    int  index()    { return _index; }
    bool mc()      { return _mc; }  // is a MC particle, e.g., matched to a hepg ptcl

    void set_px(float x)      { _px  = x; }
    void set_py(float x)      { _py  = x; }
    void set_pz(float x)      { _pz  = x; }
    void set_pt(float x)      { _pt  = x; }
    void set_en(float x)      { _en  = x; }
    void set_et(float x)      { _et  = x; }
    void set_eta(float x)     { _eta = x; }
    void set_phi(float x)     { _phi = x; }
    void set_z0(float x)      { _z0  = x; }
    void set_id(int i)        { (abs(i)==11 || abs(i)==13) ? _id = i : _id = -999; }
    void set_qual(unsigned i)  { _qual = i; }
    void set_qual2(unsigned i) { _qual2 = i; }
    void set_qual3(unsigned i) { _qual3 = i; }
    void set_index(int i)     { _index = i; }
    void set_mc(bool x)      { _mc = x; }

    void Print() const;

  private:
    float    _px;
    float    _py;
    float    _pz;
    float    _pt;
    float    _en;
    float    _et;
    float    _eta;
    float    _phi;
    float    _z0;
    int      _id;
    unsigned  _qual;
    unsigned  _qual2;
    unsigned  _qual3;
    int      _index;
    bool    _mc;

    ClassDef(Lepton, 1)
};

#endif
