#include <stdlib.h>

#include "Riostream.h"
#include "TROOT.h"
#include "TFile.h"
#include "TNetFile.h"
#include "TRandom3.h"
#include "TTree.h"
#include "TBranch.h"
#include "TClonesArray.h"
#include "TStopwatch.h"
#include "TProcessID.h"
#include "TMath.h"

#include "Example.h"

int main(int argc, char **argv)
{
    Example *ex = new Example();
    ex->SetExample();

    int Nevents = 10; int verbose = 0;
    if (argc > 1)  Nevents = atoi(argv[1]);
    if (argc > 2)  verbose = atoi(argv[2]);
    ex->SetVerbose(verbose);

    TRandom *r = new TRandom3(1);
    for ( int i=0; i<Nevents; i++ ) {
        if ( i%100 == 0 ) cout << "Processing event " << i << endl;
        int nlep = int(100.*r->Rndm());
        ex->SetNlep(nlep);
        for ( int j=0; j<nlep; j++ ) {
            ex->SetLepton(j);
        }
        ex->FillJZEvent();
    }

    ex->EndJob();
    return 0;
}
